'''
    Velvet Hotdog Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from resources.lib import Addon, velvethotdog
import sys, re, os, urllib, urllib2
from urllib2 import urlopen
import json
import xbmc, xbmcgui, xbmcplugin, xbmcaddon

addon = xbmcaddon.Addon()
addonid = addon.getAddonInfo('id')
addonname = addon.getAddonInfo('name')
plugin_path = xbmcaddon.Addon(id=addonid).getAddonInfo('path')

Addon.plugin_url = sys.argv[0]
Addon.plugin_handle = int(sys.argv[1])
Addon.plugin_queries = Addon.parse_query(sys.argv[2][1:])

dlg = xbmcgui.Dialog()

addon_logo = xbmc.translatePath(os.path.join(plugin_path,'tvaddons_logo.png'))

mode = Addon.plugin_queries['mode']

if mode == 'main':
    Addon.add_directory({'mode': 'movies_genres'}, 'Genres', img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'main', 'movies_genres.png')))
    Addon.add_directory({'mode': 'movies_recent'}, 'Recently Added', img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'main', 'movies_recent.png')))
    Addon.add_directory({'mode': 'movies_trending'}, 'Trending', img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'main', 'movies_trending.png')))
    Addon.add_directory({'mode': 'movies_popular'}, 'Popular', img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'main', 'movies_popular.png')))
    Addon.add_directory({'mode': 'movies_oscars'}, 'Oscar Winners', img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'main', 'movies_oscars.png')))
    Addon.add_directory({'mode': 'movies_search'}, 'Search', img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'main', 'movies_search.png')))

    if len(Addon.get_setting('notify')) > 0:
        Addon.set_setting('notify', str(int(Addon.get_setting('notify')) + 1))  
    else:
        Addon.set_setting('notify', "1")        
    if int(Addon.get_setting('notify')) == 1:
        xbmcgui.Dialog().notification(addonname + ' is provided by:','www.tvaddons.ag',addon_logo,5000,False)
    elif int(Addon.get_setting('notify')) == 9:
        Addon.set_setting('notify', "0")

if mode == 'movies_genres':
    genres = [
        ('Action', 'movies_action'),
        ('Adventure', 'movies_adventure'),
	('Animation', 'movies_animation'),
	('Biography', 'movies_biography'),
	('Comedy', 'movies_comedy'),
	('Crime', 'movies_crime'),
	('Drama', 'movies_drama'),
	('Family', 'movies_family'),
	('Fantasy', 'movies_fantasy'),
	('History', 'movies_history'),
	('Horror', 'movies_horror'),
	('Musical', 'movies_musical'),
	('Mystery', 'movies_mystery'),
	('Romance', 'movies_romance'),
	('Science Fiction', 'movies_sci_fi'),
	('Sport', 'movies_sport'),
	('Thriller', 'movies_thriller'),
	('War', 'movies_war'),
	('Western', 'movies_western')
	]
    for i in genres: 
        Addon.add_directory({'mode': i[1]}, i[0], img = xbmc.translatePath(os.path.join(plugin_path, 'resources', 'images', 'skin', 'genres', i[0] + '.png')))

if mode == 'movies_recent':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies('recent')
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')

if mode == 'movies_trending':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies('trending')
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_popular':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies('popular')
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa,},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_oscars':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies('oscars')
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_action':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_adventure':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_animation':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_biography':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_comedy':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_crime':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_drama':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')	
    
if mode == 'movies_family':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_fantasy':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_history':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_horror':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_music':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_musical':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_mystery':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_romance':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_sci_fi':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_sport':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_thriller':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_war':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_western':
    channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_genre(mode.replace(mode[:7], ''))
    if channels:
        for c in channels:
            title = c["title"].replace("&amp;", "&").replace('&quot;','"');
            imdb = c['imdb'];
            plot = c['plot'];
            director = c['director'];
            writer = c['writer'];
            year = c['year'];
            genre = c['genre'];
	    mpaa = c['mpaa'];
            rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
            logo = c["poster"];
            fanart = c["fanart"];
            cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
            cm_menu = [cm_refresh]
            Addon.add_video_item(rURL,
                                 {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                 img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
    xbmcplugin.setContent(Addon.plugin_handle, 'movies')
    
if mode == 'movies_search':
    search = dlg.input('Search Velvet Hotdog', type=xbmcgui.INPUT_ALPHANUM)
    if len(search) != 0:   
        try:
            channels = velvethotdog.VelvetHotdog().get_velvethotdog_movies_search(search)
            if channels:
                for c in channels:
                    title = c["title"].replace("&amp;", "&").replace('&quot;','"');
                    imdb = c['imdb'];
                    plot = c['plot'];
                    director = c['director'];
                    writer = c['writer'];
                    year = c['year'];
                    genre = c['genre'];
	            mpaa = c['mpaa'];
                    rURL = "plugin://plugin.video.velvethotdog/?imdb=" + imdb + "&mode=play_velvethotdog_movie&rand=" + Addon.random_generator()
                    logo = c["poster"];
                    fanart = c["fanart"];
                    cm_refresh = (Addon.get_string(40000), 'XBMC.RunPlugin(%s/?mode=refresh)' % (Addon.plugin_url))
                    cm_menu = [cm_refresh]
                    Addon.add_video_item(rURL,
                                     {'title': title, 'plot': plot, 'director': director, 'writer': writer, 'genre': genre, 'year': year, 'mpaa': mpaa},
                                     img=logo, fanart=fanart, playable=True, HD='High', cm=cm_menu, cm_replace=False)
            xbmcplugin.setContent(Addon.plugin_handle, 'movies')
        except:
            dlg.ok(Addon.get_string(5000), Addon.get_string(90005))
            exit()
    else:
        xbmc.executebuiltin("ActivateWindow(10025,plugin://plugin.video.velvethotdog/?mode=main)")

elif mode == 'play_velvethotdog_movie':
    imdb = Addon.plugin_queries['imdb']
    channels = []
    channels = velvethotdog.VelvetHotdog().get_link_velvethotdog_movie(imdb)
    if channels:
        for c in channels:
            url = c['url']
            item = xbmcgui.ListItem(path=url)
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)

elif mode == 'refresh':
    xbmc.executebuiltin('Container.Refresh')
                
Addon.end_of_directory()
