'''
    Velvet Hotdog Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import sys, os, re
import urllib, urllib2 ,cookielib
from urllib2 import urlopen
import json, random
import xbmcgui, xbmc, xbmcvfs
import Addon

import urlresolver

class VelvetHotdog:

    def __init__(self):
        self.dlg = xbmcgui.Dialog()
        self.aBASE_URL = 'http://json.apollogroup.tv'
        self.vBASE_URL = 'http://vodlocker.to/embed?i='

    def file_get_contents(self, url):
        url = str(url).replace(" ", "+") # just in case, no space in url
        hdr = {'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.64 Safari/537.11',
               'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
               'Accept-Charset': 'ISO-8859-1,utf-8;q=0.7,*;q=0.3',
               'Accept-Encoding': 'none',
               'Accept-Language': 'en-US,en;q=0.8',
               'Connection': 'keep-alive'}
        req = urllib2.Request(url, headers=hdr)
        try:
            page = urllib2.urlopen(req)
            return page.read()
        except urllib2.HTTPError, e:
            print e.fp.read()
        return ''

    def find_between(self, s, first, last ):
        try:
            start = s.index( first ) + len( first )
            end = s.index( last, start )
            return s[start:end]
        except ValueError:
            return ""

    def get_velvethotdog_movies(self, cat):
	content = self._get_json('/list/movie/' + cat + '.json')
	channels = []
	results = content['result'];
        if results:
	    for i in results:
	        channels.append({
	            'imdb': i['imdb'],
	            'title': i['title'],
	            'plot': i['plot'],
	            'director': i['director'],
	            'writer': i['writer'],
	            'genre': i['genres'],
	            'year': i['year'],
	            'mpaa': i['rating'],
	            'poster': i['poster'],
                    'fanart': i['fanart']
	            })
	    return channels 
        else:
            self.dlg.ok(Addon.get_string(5000), Addon.get_string(90002))
            exit()

    def get_velvethotdog_movies_genre(self, genre):
	content = self._get_json('/list/movie/genre/' + genre + '.json')
	channels = []
	results = content['result'];
        if results:
	    for i in results:
	        channels.append({
	            'imdb': i['imdb'],
	            'title': i['title'],
	            'plot': i['plot'],
	            'director': i['director'],
	            'writer': i['writer'],
	            'genre': i['genres'],
	            'year': i['year'],
	            'mpaa': i['rating'],
	            'poster': i['poster'],
                    'fanart': i['fanart']
	            })
	    return channels
        else:
            self.dlg.ok(Addon.get_string(5000), Addon.get_string(90002))
            exit()

    def get_velvethotdog_movies_search(self, search):
	content = self._get_json('/search.php', {'type': 'movie', 'search': search})
	channels = []
	results = content['result'];
        if results:
	    for i in results:
	        channels.append({
	            'imdb': i['imdb'],
	            'title': i['title'],
	            'plot': i['plot'],
	            'director': i['director'],
	            'writer': i['writer'],
	            'genre': i['genres'],
	            'year': i['year'],
	            'mpaa': i['rating'],
	            'poster': i['poster'],
                    'fanart': i['fanart']
	            })
	    return channels 
        else:
            self.dlg.ok(Addon.get_string(5000), Addon.get_string(90005))
            exit()

    def get_link_velvethotdog_movie(self, imdb):
	channels = []
        try:
	    url = self.vBASE_URL + str(imdb)
            stream = self.file_get_contents(url)

            if 'googlevideo' in stream: 
                stream = self.find_between(stream, "<source src='", "'" )
            else:
                url = self.find_between(stream, 'url: "', "&" )
                stream = self.file_get_contents(url)
                stream = self.find_between(stream, "<input value='", "'" )
	    channels.append({
	        'url': urlresolver.resolve(stream)
	    })
	    return channels
        except:
            self.dlg.ok(Addon.get_string(5000), Addon.get_string(90005))
            exit()

    def _build_url(self, path, queries={}):
        if queries:
            query = Addon.build_query(queries)
            return '%s/%s?%s' % (self.aBASE_URL, path, query)
        else:
            return '%s/%s' % (self.aBASE_URL, path)

    def _build_json(self, path, queries={}):
        if queries:
            query = urllib.urlencode(queries)
            return '%s/%s?%s' % (self.aBASE_URL, path, query)
        else:
            return '%s/%s' % (self.aBASE_URL, path)

    def _fetch(self, url, form_data=False):
        opener = urllib2.build_opener()
        opener.addheaders = [('User-agent', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.64 Safari/537.11')]
        if form_data:
            req = urllib2.Request(url, form_data)
        else:
            req = url
        try:
            response = opener.open(req)
            return response
        except urllib2.URLError, e:
            return False

    def _get_json(self, path, queries={}):
        content = False
        url = self._build_json(path, queries)
        response = self._fetch(url)
        if response:
            content = json.loads(response.read())
        else:
            content = False
        return content

    def _get_html(self, path, queries={}):
        html = False
        url = self._build_url(path, queries)
   
        response = self._fetch(url)
        if response:
            html = response.read()
        else:
            html = False
        return html
